﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using System.Threading;

using StockholmLibrary.Net;
using StockholmLibrary.Util;

namespace StockholmLibrary.Game
{
    //------------------------------------
    public class GameManager
    {
        private Handlers.Generic.GenericUserHandler _genericUserHandler;
        private Handlers.Generic.GenericNavigatorHandler _genericNavigatorHandler;

        private Game.Sessions.SessionManager _sessionManager;
        private Game.Sessions.RoleManager _roleManager;
        private Game.Util.DataValidator _dataValidator;
        private Game.Util.UserTools _userTools;
        private Game.Util.InputFiltering _inputFiltering;

        private Game.Flats.FlatManager _flatManager;

        //**********************************************
        public Game.Sessions.SessionManager SessionManager
        {
            get
            {
                return _sessionManager;
            }
        }

        //**********************************************
        public Game.Util.DataValidator DataValidator
        {
            get
            {
                return _dataValidator;
            }
        }

        //**********************************************
        public Game.Util.InputFiltering InputFiltering
        {
            get
            {
                return _inputFiltering;
            }
        }

        //**********************************************
        public Game.Util.UserTools UserTools
        {
            get
            {
                return _userTools;
            }
        }

        //**********************************************
        public Game.Sessions.RoleManager RoleManager
        {
            get
            {
                return _roleManager;
            }
        }

        //**********************************************
        public Game.Flats.FlatManager FlatManager
        {
            get
            {
                return _flatManager;
            }
        }

        //**********************************************
        public GameManager()
        {
            _genericUserHandler = new Handlers.Generic.GenericUserHandler();
            _genericNavigatorHandler = new Handlers.Generic.GenericNavigatorHandler();
            _sessionManager = new Sessions.SessionManager();
            _roleManager = new Sessions.RoleManager();
            _flatManager = new Flats.FlatManager();
            _dataValidator = new Util.DataValidator();
            _userTools = new Util.UserTools();
            _inputFiltering = new Util.InputFiltering();
        }
    }
}
