﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using StockholmLibrary.Net;
namespace StockholmLibrary.Game.Packets.Client
{
    //------------------------------------
    public class SayPacket : ClientPacketDeserialiser
    {
        public string Text;

        //**********************************************
        public override void Deserialise(ClientPacket packet)
        {
            base.Deserialise(packet);
            this.Text = packet.ReadArgumentString();
        }
    }

    //------------------------------------
    public class ShoutPacket : ClientPacketDeserialiser
    {
        public string Text;

        //**********************************************
        public override void Deserialise(ClientPacket packet)
        {
            base.Deserialise(packet);
            this.Text = packet.ReadArgumentString();
        }
    }

    //------------------------------------
    public class WhisperPacket : ClientPacketDeserialiser
    {
        public string Name;
        public string Text;

        //**********************************************
        public override void Deserialise(ClientPacket packet)
        {
            base.Deserialise(packet);
            string text = packet.ReadArgumentString();
            int seperator = text.IndexOf(' ');
            if (seperator != -1)
            {
                Name = text.Substring(0, seperator);
                Text = text.Substring(seperator + 1);
            }
        }
    }
}
