﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;

using StockholmLibrary.Net;

namespace StockholmLibrary.Game.Packets.Server
{
    //------------------------------------
    public class ServerSayPacket : ServerPacket
    {
        private string _message;
        private int _creatureId;

        //**********************************************
        public ServerSayPacket(int creatureId, string message)
        {
            _packetType = EServerPacket.SAY;
            _creatureId = creatureId;
            _message = message;
        }

        //**********************************************
        protected override void SerialiseBody()
        {
            WriteIntWired(_creatureId);
            WriteStringRaw(_message);
            WriteListDelimiter();
        }
    }

    //------------------------------------
    public class ServerShoutPacket : ServerPacket
    {
        private string _message;
        private int _creatureId;

        //**********************************************
        public ServerShoutPacket(int creatureId, string message)
        {
            _packetType = EServerPacket.SHOUT;
            _creatureId = creatureId;
            _message = message;
        }

        //**********************************************
        protected override void SerialiseBody()
        {
            WriteIntWired(_creatureId);
            WriteStringRaw(_message);
            WriteListDelimiter();
        }
    }

    //------------------------------------
    public class ServerWhisperPacket : ServerPacket
    {
        private string _message;
        private int _creatureId;

        //**********************************************
        public ServerWhisperPacket(int creatureId, string message)
        {
            _packetType = EServerPacket.WHISPER;
            _creatureId = creatureId;
            _message = message;
        }

        //**********************************************
        protected override void SerialiseBody()
        {
            WriteIntWired(_creatureId);
            WriteStringRaw(_message);
            WriteListDelimiter();
        }
    }
}
